<?php

// EQdkp required files/vars
define('EQDKP_INC', true);
define('PLUGIN', 'titandkp');

// set the paths
$eqdkp->config['server_path'] = $eqdkp->config['server_path'] . '../../';
$eqdkp_root_path = $eqdkp->config['server_path'];

include_once($eqdkp_root_path.'common.php');

$titandkp = $pm->get_plugin('titandkp');

if (!$pm->check(PLUGIN_INSTALLED, 'titandkp')) {
    message_die('The TitanDKP plugin is not installed.');
}

if (!$user->check_auth('u_member_list')) {
    message_die($user->lang['noauth_u_member_list']);
}

// Page display
function displayMembers() {
	global $tpl, $SID, $user, $eqdkp, $pm;
 
	// set template variables   
	$tpl->assign_vars(array(
		'F_FORM_ACTION'		=> 'list_alts.php' . $SID,
		'S_LISTMEMBERS'		=> true,
		'L_NAME'			=> $user->lang['titandkp_alt_name'],
		'L_ALTS'			=> $user->lang['titandkp_alt_alts'],
	));
	
	$row = 1;
	$members = getMembers();
	foreach ($members as $member => $membervar) {
		$tpl->assign_block_vars('character_row', array(
			'CHARACTER' => $member,
			'CLASS'		=> "row".$row,
		));
		$row = ($row % 2) + 1;
		
		$alts = getAlts($member);
		foreach ($alts as $alt => $altvar) {
			// check that alt is still a member
			if ($members[$alt] !== $alt) {
				clearAlt($alt);
			}
			else {			
				$tpl->assign_block_vars('character_row.alt_row', array(
					'ALT' => $alt, 
				));
			}
		}
	}
	
	$eqdkp->set_vars(array(
		'page_title'        => sprintf($user->lang['admin_title_prefix'], $eqdkp->config['guildtag'], $eqdkp->config['dkp_name'])
			.': '.$user->lang['titandkp_showalts_pagetitle'],
		'template_path'		=> $pm->get_data('titandkp', 'template_path'),
		'template_file'     => 'list_alts.html',
		'display'           => true,
	));
}

// get members
function getMembers() {
	global $db;
	$memberRows = $db->query("SELECT `member_name` FROM ".MEMBERS_TABLE.";");
	
	$members = array();
	while ($memberRow = $db->fetch_record($memberRows)) {
		$members[$memberRow['member_name']] = $memberRow['member_name'];
	}
	
	$db->free_result($memberRows);
	
	return $members;
}

// get alts
function getAlts($name) {
	global $db;
	$altRows = $db->query("SELECT `alt_name` FROM ".MEMBERS_ALTS_TABLE." WHERE `member_name` = '".
	$name."';");
	
	$alts = array();
	while ($altRow = $db->fetch_record($altRows)) {
		$alts[$altRow['alt_name']] = $altRow['alt_name'];
	}
	
	$db->free_result($altRows);
	
	return $alts;
}
    
function clearAlt($alt) {
	global $db;
	
	$db->query("DELETE FROM ".MEMBERS_ALTS_TABLE." WHERE `alt_name` = '".$alt."';");
}

// call the functions
displayMembers();

?>