<?php

// EQdkp required files/vars
define('EQDKP_INC', true);
define('IN_ADMIN', true);
define('PLUGIN', 'titandkp');

// set the paths
$eqdkp->config['server_path'] = $eqdkp->config['server_path'] . '../../';
$eqdkp_root_path = $eqdkp->config['server_path'];

include_once($eqdkp_root_path . 'common.php');

$titandkp = $pm->get_plugin('titandkp');

if (!$pm->check(PLUGIN_INSTALLED, 'titandkp')) {
    message_die('The TitanDKP plugin is not installed.');
}

class TITANDKP_Alt extends EQdkp_Admin {
	// called when processed
    function titandkp_Alt() {
        global $db, $eqdkp, $user, $tpl, $pm;
        global $SID;
        
        parent::eqdkp_admin();
        
        // show correct form
        $this->assoc_buttons(array(
            'form' => array(
                'name'    => '',
                'process' => 'displayMembers',
                'check'   => 'a_members_man'
            ),
            'editalts' => array(
                'name'    => 'editalts',
                'process' => 'showAlt',
                'check'   => 'a_members_man'
            ),
            'altname' => array(
                'name'    => 'altname',
                'process' => 'deleteAlt',
                'check'   => 'a_members_man'
            ),
            'changealt' => array(
                'name'    => 'changealt',
                'process' => 'updateAlt',
                'check'   => 'a_members_man'
            )
        ));
    }
    
    // Page display
    function displayMembers() {
        global $tpl, $SID, $user, $eqdkp, $pm;
     
        // set template variables   
        $tpl->assign_vars(array(
            'F_FORM_ACTION'		=> 'manage_alts.php' . $SID,
            'S_LISTMEMBERS'		=> true,
            'S_CHANGEALT'		=> false,
            'L_NAME'			=> $user->lang['titandkp_alt_name'],
            'L_ALTS'			=> $user->lang['titandkp_alt_alts'],
        ));
		
		$row = 1;
		$members = $this->getMembers();
        foreach ($members as $member => $membervar) {
        	$tpl->assign_block_vars('character_row', array(
				'CHARACTER' => $member,
				'CLASS'		=> "row".$row,
			));
			$row = ($row % 2) + 1;
        	
			$alts = $this->getAlts($member);
			foreach ($alts as $alt => $altvar) {
				// check that alt is still a member
				if ($members[$alt] !== $alt) {
					$this->clearAlt($alt);
				}
				else {
					$tpl->assign_block_vars('character_row.alt_row', array(
						'ALT' => $alt, 
					));
				}
			}
        }
        
        $eqdkp->set_vars(array(
            'page_title'        => sprintf($user->lang['admin_title_prefix'], $eqdkp->config['guildtag'], $eqdkp->config['dkp_name'])
            	.': '.$user->lang['titandkp_showalts_pagetitle'],
            'template_path'		=> $pm->get_data('titandkp', 'template_path'),
            'template_file'     => 'manage_alts.html',
            'display'           => true,
		));
    }
    
    // update alt, redisplay edit page
    function updateAlt() {
    	global $db;
		$member = "";
		if ($_POST['editalts']) {
			$member = $_POST['editalts'];
		}
		else {
			$member = $_POST['membername'];
		}
		$alt = $_POST['altlist'];
		
		$db->query("INSERT INTO ".MEMBERS_ALTS_TABLE." (`member_name`, `alt_name`) VALUES ('"
			.mysql_escape_string($member)."', '".mysql_escape_string($alt)."');");
			
    	$this->showAlt();
    }
    
    function deleteAlt() {
    	global $db;
		$member = $_POST['membername'];
		$alt = $_POST['altname'];
		
		$db->query("DELETE FROM ".MEMBERS_ALTS_TABLE." WHERE `member_name` = '".$member
			."' AND `alt_name` = '".$alt."';");
			
    	$this->showAlt();
    }
    
    // show edit page
    function showAlt() {
        global $tpl, $SID, $user, $eqdkp, $pm;
		
		$member = "";
		if ($_POST['editalts']) {
			$member = $_POST['editalts'];
		}
		else {
			$member = $_POST['membername'];
		}
     
        // set template variables   
        $tpl->assign_vars(array(
            'F_FORM_ACTION'		=> 'manage_alts.php'.$SID,
            'S_LISTMEMBERS'		=> false,
            'S_CHANGEALT'		=> true,
            'L_NAME'			=> $user->lang['titandkp_alt_name'],
            'L_ALTS'			=> $user->lang['titandkp_alt_alts'],
            'L_ALTS_TITLE'		=> $user->lang['titandkp_alt_edit'],
            'L_CHARACTER'		=> $member,
            'L_FORM_BACK'		=> $user->lang['titandkp_alt_back'],
            'L_FORM_SUBMIT'		=> $user->lang['titandkp_alt_submit'],
        ));
		
		$members = $this->getMembers();
		$alts = $this->getAlts($member);
		foreach ($alts as $alt => $altvar) {
			// check that alt is still a member
			if ($members[$alt] !== $alt) {
				$this->clearAlt($alt);
			}
			else {
				$tpl->assign_block_vars('alt_row', array(
					'ALT' => $alt,
				));
			}
		}
		
		foreach ($members as $membername => $membernamevar) {
			if ($member !== $membername && $alts[$membername] !== $membername) {
				$tpl->assign_block_vars('select_row', array(
					'ALT' => $membername,
				));
			}
		}
        
        $eqdkp->set_vars(array(
            'page_title'        => sprintf($user->lang['admin_title_prefix'], $eqdkp->config['guildtag'], $eqdkp->config['dkp_name'])
            	.': '. sprintf($user->lang['titandkp_editalt_pagetitle'], $member),
            'template_path'		=> $pm->get_data('titandkp', 'template_path'),
            'template_file'     => 'manage_alts.html',
            'display'           => true,
		));
    }
    
    // get members
    function getMembers() {
    	global $db;
		$memberRows = $db->query("SELECT `member_name` FROM ".MEMBERS_TABLE.";");
		
		$members = array();
		while ($memberRow = $db->fetch_record($memberRows)) {
			$members[$memberRow['member_name']] = $memberRow['member_name'];
		}
		
		$db->free_result($memberRows);
		
		return $members;
    }
    
    // get alts
    function getAlts($name) {
    	global $db;
		$altRows = $db->query("SELECT `alt_name` FROM ".MEMBERS_ALTS_TABLE." WHERE `member_name` = '".
		$name."';");
		
		$alts = array();
		while ($altRow = $db->fetch_record($altRows)) {
			$alts[$altRow['alt_name']] = $altRow['alt_name'];
		}
		
		$db->free_result($altRows);
		
		return $alts;
    }
    
	function clearAlt($alt) {
		global $db;
		
		$db->query("DELETE FROM ".MEMBERS_ALTS_TABLE." WHERE `alt_name` = '".$alt."';");
	}
}

// call the functions
$alt = new TITANDKP_Alt;
$alt->process();

?>